/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
var app = {
  // Application Constructor
  initialize: function() {
    document.addEventListener('deviceready', this.onDeviceReady.bind(this), false);
    document.addEventListener("offline", this.onOffline.bind(this), false);
    document.addEventListener("online", this.onOnline.bind(this), false);
    document.addEventListener("pause", this.onPause.bind(this), false);
    window.addEventListener('beforeunload', this.onDestroy.bind(this), false);
  },
  // deviceready Event Handler
  //
  // Bind any cordova events here. Common events are:
  // 'pause', 'resume', etc.
  onDeviceReady: function() {
    //        cordova.plugins.PowerOptimization.IsIgnoringBatteryOptimizations().then((result) => {
    //            console.log(result);
    //        }, (err) => {
    //            console.error(err);
    //        });

    // start media session
    startMediaSession();

    window.powerManagement.acquire(function() {
      console.log('Total Wakelock acquired.');
    }, function() {
      console.log('Failed to acquire total wakelock.');
    });

    window.powerManagement.dim(function() {
      console.log('Wakelock partially acquired.');
    }, function() {
      console.log('Failed to acquire partially wakelock.');
    });

    window.powerManagement.setReleaseOnPause(false, function() {
      console.log('ReleaseOnPause set to FALSE successfully.');
    }, function() {
      console.log('Failed to set FALSE on ReleaseOnPause.');
    });

    let connectionType = this.checkConnection();
    if (connectionType === 'No network connection') {
      errore_popup();
    } else {
      // QUI diciamo se va tutto bene carica l'audio
      //document.getElementById('rcfplay').load();
      //document.getElementById('rcfplay').play();

      //$("#buttonpp").removeClass("play");
      //$("#buttonpp").addClass("paused");

      //changeplaypause();
      frasedelgiorno(i);

      var btnp = $("#buttonpause");
      var btnpl = $("#buttonplay");

      btnp.click(function() {
        document.getElementById('rcfplay').pause();
        console.log("start pause");
        MusicControls.updateIsPlaying(false);
        btnp.toggle();
        btnpl.toggle();
        return false;
      });
      btnpl.click(function() {
        document.getElementById('rcfplay').load();
        document.getElementById('rcfplay').play();
        console.log("start play");
        MusicControls.updateIsPlaying(true);
        btnpl.toggle();
        btnp.toggle();
        return true;
      });
    }
  },
  //Invocata quando un dispositivo connesso va offline
  onOffline: function() {

    console.log("OFFLINE");
    errore_popup();
  },
  //Invocata quando un dispositivo disconnesso va online
  onOnline: function() {
    //FIXME che facciamo qui?
    console.log("ONLINE");
    WiFiLock.release()
      .then(function(value) {
        console.log("Released WIFI lock. " + value);
      })
      .catch(function(reason) {
        console.log("Failed releasing WIFI lock." + reason);
      });
  },
  onPause: function() {
    console.log("PAUSE");
    WiFiLock.acquire()
      .then(function(value) {
        console.log("Acquired WIFI lock. " + value);
      })
      .catch(function(reason) {
        console.log("Failed acquiring WIFI lock." + reason);
      });
  },
  checkConnection: function() {
    var networkState = navigator.connection.type;
    var states = {};
    states[Connection.UNKNOWN] = 'Unknown connection';
    states[Connection.ETHERNET] = 'Ethernet connection';
    states[Connection.WIFI] = 'WiFi connection';
    states[Connection.CELL_2G] = 'Cell 2G connection';
    states[Connection.CELL_3G] = 'Cell 3G connection';
    states[Connection.CELL_4G] = 'Cell 4G connection';
    states[Connection.CELL] = 'Cell generic connection';
    states[Connection.NONE] = 'No network connection';

    return states[networkState];
  },
  openpopup: function(selector) {
    $(selector).css("display", "block");

    //forse questo qui non va bene senza vuotare gli handler prima.
    $(selector + " > .close_popoup_button").click(function() {
      $(selector).css("display", "none");
    });
  },
  onDestroy: function() {
    MusicControls.destroy();
  }

};

function errore_popup() {
  $("#popupnetwork").css("display", "block");
  $("#popupnetwork > .close_popoup_button").click(function() {
    $("#popupnetwork").css("display", "none");
  });
}


app.initialize();

let i=1;

// https://www.joomla.it/articoli-della-community.feed?type=rss
// http://api.jquery.com/jquery.ajax/
//https://www.test-cors.org/
function frasedelgiorno() {
  $("#feedtitolo").empty();
  $("#news > h2").html('ULTIME NOTIZIE');
  $("#feedtitolo").attr("href","#");

  $.ajax({
    'async': true,
    'global': false,
    'url': "https://www.radiocittafujiko.it/wp-json/wp/v2/posts",
    'dataType': 'json',
    'contentType': "application/json;charset=utf-8",
    'success': function(data) {

      var obj = JSON.stringify(data);
      var artsRSS = JSON.parse(obj);
      var artRSS = artsRSS[1];

      var linkRSS = artRSS.link;
      var titleRSS = artRSS.title.rendered;
      var excerptRSS = artRSS.excerpt.rendered;
      var dateRSS = new Date(artRSS.date);
      var dateRSS = new Intl.DateTimeFormat('it', {
        year: 'numeric', month: 'numeric', day: 'numeric',
        hour: 'numeric', minute: 'numeric', // second: 'numeric',
      }).format(dateRSS);

      // title
      var rssTitle = document.createElement("h2");
      $("#news img").css("display", "none");
      $("#feedtitolo").append(rssTitle);
      $("#feedtitolo").innerHTML = titleRSS;
      rssTitle.innerHTML = titleRSS;
      // link
      $("#feedtitolo").attr("href", linkRSS);
      // excerpt
      $("#feedtitolo").append(excerptRSS);
      // date
      var rssSpan = $("#news > h2")[0];
      rssSpan.innerHTML = rssSpan.innerHTML + " - " + dateRSS;

      $("#feedtitolo *").attr('style', 'font-weight:400');
      $("#feedtitolo h2").attr('style', 'font-size: 1.2em;');

      setTimeout(function() {
        frasedelgiorno();
        console.log("aspetta");
      }, 900000);

    },
    'error': function() {
      console.log("errore");
    }
  });



}


function startMediaSession() {
  MusicControls.create({
    track       : '103.1fm',		// optional, default : ''
    artist      : 'RadioCittàFujiko',						// optional, default : ''
    // album       : 'Absolution',     // optional, default: ''
    cover       : 'img/splash-land-ldpi.png',		// optional, default : nothing
    // cover can be a local path (use fullpath 'file:///storage/emulated/...', or only 'my_image.jpg' if my_image.jpg is in the www folder of your app)
    //			 or a remote url ('http://...', 'https://...', 'ftp://...')
    isPlaying   : false,							// optional, default : true
    dismissable : true,							// optional, default : false

    // hide previous/next/close buttons:
    hasPrev   : false,		// show previous button, optional, default: true
    hasNext   : false,		// show next button, optional, default: true
    hasClose  : false,		// show close button, optional, default: false

    // iOS only, optional

    duration : 60, // optional, default: 0
    elapsed : 10, // optional, default: 0
      hasSkipForward : true, //optional, default: false. true value overrides hasNext.
      hasSkipBackward : true, //optional, default: false. true value overrides hasPrev.
      skipForwardInterval : 15, //optional. default: 0.
    skipBackwardInterval : 15, //optional. default: 0.
    hasScrubbing : false, //optional. default to false. Enable scrubbing from control center progress bar

    // Android only, optional
    // text displayed in the status bar when the notification (and the ticker) are updated
    ticker	  : 'Now playing "RadioCittàFujiko"',
    //All icons default to their built-in android equivalents
    //The supplied drawable name, e.g. 'media_play', is the name of a drawable found under android/res/drawable* folders
    playIcon: 'media_play',
    pauseIcon: 'media_pause',
    // prevIcon: 'media_prev',
    // nextIcon: 'media_next',
    // closeIcon: 'media_close',
    notificationIcon: 'notification'
  });

  // MusicControls.destroy();

  // // Register callback
  MusicControls.subscribe(events);

  // Start listening for events
  // The plugin will run the events function each time an event is fired
  MusicControls.listen();

}



function events(action) {

  var btnp = $("#buttonpause");
  var btnpl = $("#buttonplay");

  const message = JSON.parse(action).message;
  switch(message) {
    case 'music-controls-next':
      // Do something
      break;
    case 'music-controls-previous':
      // Do something
      break;
    case 'music-controls-pause':
      // Metti in pausa
      btnp.click();
      break;
    case 'music-controls-play':
      // Metti play
      btnpl.click();
      break;
    case 'music-controls-destroy':
      // Metti in pausa
      if (!document.getElementById('rcfplay').paused) {
        btnp.click();
      }
      MusicControls.destroy();
      break;
      case 'music-controls-toggle-play-pause' :
      // Do something
      break;
    // Lockscreen seek controls (iOS only)
      case 'music-controls-seek-to':
      const seekToInSeconds = JSON.parse(action).position;
      MusicControls.updateElapsed({
        elapsed: seekToInSeconds,
        isPlaying: true
      });
      // Do something
      break;

    // Headset events (Android only)
    // All media button events are listed below
    case 'music-controls-media-button' :
      // Do something
      break;
    case 'music-controls-headset-unplugged':
      // Do something
      break;
    case 'music-controls-headset-plugged':
      // Do something
      break;
    default:
      break;
  }
}
